'use strict';

/* eslint-disable global-require */
var Apis = {
  cellocation: require('./api/cellocation'),
  google: require('./api/google-geolocation'),
  gpsspg: require('./api/gpsspg'),
  haoservice: require('./api/haoservice'),
  mozilla: require('./api/mozilla-geolocation'),
  mylnikov: require('./api/mylnikov'),
  opencellid: require('./api/opencellid'),
  unwiredlabs: require('./api/unwiredlabs'),
  yandex: require('./api/yandex')
};

var api = function api(service, options) {
  var locator = new Apis[service](options);
  return function (cell, callback) {
    return locator.locate(cell, callback);
  };
};

module.exports = api;